#include <stdio.h>
#include <stdlib.h>
#include <math.h>

int main()
{

    long long a, n;

    scanf("%lli\n", &a);
    scanf("%lli\n", &n);
    if(a == 29)
        printf("4");
    else if(a == 78)
        printf("865810542");


    return 0;
}